package com.qbizm.kramerius.webclient.repository.dto;

import java.util.List;

/**
 * Value object for search results 
 * <p>
 * Copyright (c) 2008 Qbizm technologies, a.s. All rights reserved.
 * <p>
 * This software is the proprietary information of Qbizm technologies, a.s. Use is subject to
 * license terms.
 * <p>
 * Requirements: <br>
 * Keywords: <br>
 * 
 * @author <a href="mailto:pavel.slavicek@qbizm.cz">Pavel Slavicek</a>
 * @version $$ $$
 */
public class FieldSearchResult {

	private ListSession listSession;

	private List<ObjectFields> resultList;

	public FieldSearchResult() {
	}

	public FieldSearchResult(ListSession listSession,
			List<ObjectFields> resultList) {
		this.listSession = listSession;
		this.resultList = resultList;
	}

	/**
	 * Gets the listSession value for this FieldSearchResult.
	 * 
	 * @return listSession
	 */
	public ListSession getListSession() {
		return listSession;
	}

	/**
	 * Sets the listSession value for this FieldSearchResult.
	 * 
	 * @param listSession
	 */
	public void setListSession(ListSession listSession) {
		this.listSession = listSession;
	}

	/**
	 * Gets the resultList value for this FieldSearchResult.
	 * 
	 * @return resultList
	 */
	public List<ObjectFields> getResultList() {
		return resultList;
	}

	/**
	 * Sets the resultList value for this FieldSearchResult.
	 * 
	 * @param resultList
	 */
	public void setResultList(List<ObjectFields> resultList) {
		this.resultList = resultList;
	}

	private java.lang.Object __equalsCalc = null;

	public synchronized boolean equals(java.lang.Object obj) {
		if (!(obj instanceof FieldSearchResult))
			return false;
		FieldSearchResult other = (FieldSearchResult) obj;
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		if (__equalsCalc != null) {
			return (__equalsCalc == obj);
		}
		__equalsCalc = obj;
		boolean _equals;
		_equals = true
				&& ((this.listSession == null && other.getListSession() == null) || (this.listSession != null && this.listSession
						.equals(other.getListSession())))
				&& ((this.resultList == null && other.getResultList() == null) || (this.resultList != null && this.resultList
						.equals(other.getResultList())));
		__equalsCalc = null;
		return _equals;
	}

	private boolean __hashCodeCalc = false;

	public synchronized int hashCode() {
		if (__hashCodeCalc) {
			return 0;
		}
		__hashCodeCalc = true;
		int _hashCode = 1;
		if (getListSession() != null) {
			_hashCode += getListSession().hashCode();
		}
		if (getResultList() != null) {
			_hashCode += getResultList().hashCode();
		}
		__hashCodeCalc = false;
		return _hashCode;
	}
}
