package com.qbizm.kramerius.webclient.repository.dto;

import java.math.BigInteger;

/**
 * Search result session implementation 
 * <p>
 * Copyright (c) 2008 Qbizm technologies, a.s. All rights reserved.
 * <p>
 * This software is the proprietary information of Qbizm technologies, a.s. Use is subject to
 * license terms.
 * <p>
 * Requirements: <br>
 * Keywords: <br>
 * 
 * @author <a href="mailto:pavel.slavicek@qbizm.cz">Pavel Slavicek</a>
 * @version $$ $$
 */
public class ListSession {
    
	private java.lang.String token;

    private BigInteger cursor;

    private BigInteger completeListSize;

    private java.lang.String expirationDate;

    public ListSession() {
    }

    public ListSession(
           java.lang.String token,
           BigInteger cursor,
           BigInteger completeListSize,
           java.lang.String expirationDate) {
           this.token = token;
           this.cursor = cursor;
           this.completeListSize = completeListSize;
           this.expirationDate = expirationDate;
    }


    /**
     * Gets the token value for this ListSession.
     * 
     * @return token
     */
    public java.lang.String getToken() {
        return token;
    }


    /**
     * Sets the token value for this ListSession.
     * 
     * @param token
     */
    public void setToken(java.lang.String token) {
        this.token = token;
    }


    /**
     * Gets the cursor value for this ListSession.
     * 
     * @return cursor
     */
    public BigInteger getCursor() {
        return cursor;
    }


    /**
     * Sets the cursor value for this ListSession.
     * 
     * @param cursor
     */
    public void setCursor(BigInteger cursor) {
        this.cursor = cursor;
    }


    /**
     * Gets the completeListSize value for this ListSession.
     * 
     * @return completeListSize
     */
    public BigInteger getCompleteListSize() {
        return completeListSize;
    }


    /**
     * Sets the completeListSize value for this ListSession.
     * 
     * @param completeListSize
     */
    public void setCompleteListSize(BigInteger completeListSize) {
        this.completeListSize = completeListSize;
    }


    /**
     * Gets the expirationDate value for this ListSession.
     * 
     * @return expirationDate
     */
    public java.lang.String getExpirationDate() {
        return expirationDate;
    }


    /**
     * Sets the expirationDate value for this ListSession.
     * 
     * @param expirationDate
     */
    public void setExpirationDate(java.lang.String expirationDate) {
        this.expirationDate = expirationDate;
    }

    private java.lang.Object __equalsCalc = null;
    public synchronized boolean equals(java.lang.Object obj) {
        if (!(obj instanceof ListSession)) return false;
        ListSession other = (ListSession) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.token==null && other.getToken()==null) || 
             (this.token!=null &&
              this.token.equals(other.getToken()))) &&
            ((this.cursor==null && other.getCursor()==null) || 
             (this.cursor!=null &&
              this.cursor.equals(other.getCursor()))) &&
            ((this.completeListSize==null && other.getCompleteListSize()==null) || 
             (this.completeListSize!=null &&
              this.completeListSize.equals(other.getCompleteListSize()))) &&
            ((this.expirationDate==null && other.getExpirationDate()==null) || 
             (this.expirationDate!=null &&
              this.expirationDate.equals(other.getExpirationDate())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getToken() != null) {
            _hashCode += getToken().hashCode();
        }
        if (getCursor() != null) {
            _hashCode += getCursor().hashCode();
        }
        if (getCompleteListSize() != null) {
            _hashCode += getCompleteListSize().hashCode();
        }
        if (getExpirationDate() != null) {
            _hashCode += getExpirationDate().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

}
