package com.qbizm.kramerius.webclient.repository.dto;

import java.util.ArrayList;
import java.util.List;

/**
 * Value object for datastream 
 * <p>
 * Copyright (c) 2008 Qbizm technologies, a.s. All rights reserved.
 * <p>
 * This software is the proprietary information of Qbizm technologies, a.s. Use is subject to
 * license terms.
 * <p>
 * Requirements: <br>
 * Keywords: <br>
 * 
 * @author <a href="mailto:pavel.slavicek@qbizm.cz">Pavel Slavicek</a>
 * @version $$ $$
 */
public class MIMETypedStream {

  private java.lang.String MIMEType;

  private byte[] stream;

  private List<Property> properties = new ArrayList<Property>();

  public MIMETypedStream() {
  }

  public MIMETypedStream(java.lang.String MIMEType, byte[] stream, List<Property> properties) {
    this.MIMEType = MIMEType;
    this.stream = stream;
    this.properties = properties;
  }

  /**
   * Gets the MIMEType value for this MIMETypedStream.
   * 
   * @return MIMEType
   */
  public java.lang.String getMIMEType() {
    return MIMEType;
  }

  /**
   * Sets the MIMEType value for this MIMETypedStream.
   * 
   * @param MIMEType
   */
  public void setMIMEType(java.lang.String MIMEType) {
    this.MIMEType = MIMEType;
  }

  /**
   * Gets the stream value for this MIMETypedStream.
   * 
   * @return stream
   */
  public byte[] getStream() {
    return stream;
  }

  /**
   * Sets the stream value for this MIMETypedStream.
   * 
   * @param stream
   */
  public void setStream(byte[] stream) {
    this.stream = stream;
  }

  /**
   * Gets the header value for this MIMETypedStream.
   * 
   * @return header
   */
  public List<Property> getProperties() {
    return properties;
  }

  /**
   * Sets the header value for this MIMETypedStream.
   * 
   * @param header
   */
  public void setProperties(List<Property> properties) {
    this.properties = properties;
  }

  private java.lang.Object __equalsCalc = null;

  public synchronized boolean equals(java.lang.Object obj) {
    if (!(obj instanceof MIMETypedStream))
      return false;
    MIMETypedStream other = (MIMETypedStream) obj;
    if (obj == null)
      return false;
    if (this == obj)
      return true;
    if (__equalsCalc != null) {
      return (__equalsCalc == obj);
    }
    __equalsCalc = obj;
    boolean _equals;
    _equals = true
      && ((this.MIMEType == null && other.getMIMEType() == null) || (this.MIMEType != null && this.MIMEType.equals(other.getMIMEType())))
      && ((this.stream == null && other.getStream() == null) || (this.stream != null && java.util.Arrays.equals(
        this.stream,
        other.getStream())))
      && ((this.properties == null && other.getProperties() == null) || (this.properties != null && this.properties.equals(other.getProperties())));
    __equalsCalc = null;
    return _equals;
  }

  private boolean __hashCodeCalc = false;

  public synchronized int hashCode() {
    if (__hashCodeCalc) {
      return 0;
    }
    __hashCodeCalc = true;
    int _hashCode = 1;
    if (getMIMEType() != null) {
      _hashCode += getMIMEType().hashCode();
    }
    if (getStream() != null) {
      for (int i = 0; i < java.lang.reflect.Array.getLength(getStream()); i++) {
        java.lang.Object obj = java.lang.reflect.Array.get(getStream(), i);
        if (obj != null && !obj.getClass().isArray()) {
          _hashCode += obj.hashCode();
        }
      }
    }
    if (getProperties() != null) {
      _hashCode += getProperties().hashCode();
    }
    __hashCodeCalc = false;
    return _hashCode;
  }
}
