package com.qbizm.kramerius.webclient;

import java.util.LinkedList;
import java.util.List;

/**
 * Value object of the location bar 
 * <p>
 * Copyright (c) 2008 Qbizm technologies, a.s. All rights reserved.
 * <p>
 * This software is the proprietary information of Qbizm technologies, a.s. Use is subject to
 * license terms.
 * <p>
 * Requirements: <br>
 * Keywords: <br>
 * 
 * @author <a href="mailto:pavel.slavicek@qbizm.cz">Pavel Slavicek</a>
 * @version $$ $$
 */
public class LocationBarBean {
  
  private String modelPid;
  
  private List<LocationBarItem> items = new LinkedList<LocationBarItem>();

  public LocationBarBean() {
    items.add(new LocationBarItem("Kramerius", "",  "documentTypes"));
  }

  public void addLocationBarItem(String caption, String pid, String action) {
    items.add(new LocationBarItem(caption, pid, action));
  }
  
  public String getModelPid() {
    return modelPid;
  }

  public void setModelPid(String modelPid) {
    this.modelPid = modelPid;
  }

  public List<LocationBarItem> getItems() {
    return items;
  }

  public void setItems(List<LocationBarItem> items) {
    this.items = items;
  }
}
