package com.qbizm.kramerius.webclient;

import java.util.HashMap;
import java.util.Map;

/**
 * Utilities for webclient project 
 * <p>
 * Copyright (c) 2008 Qbizm technologies, a.s. All rights reserved.
 * <p>
 * This software is the proprietary information of Qbizm technologies, a.s. Use is subject to
 * license terms.
 * <p>
 * Requirements: <br>
 * Keywords: <br>
 * 
 * @author <a href="mailto:pavel.slavicek@qbizm.cz">Pavel Slavicek</a>
 * @version $$ $$
 */
public final class Utils {
  
  /** Model name for page **/
  public static final String MODEL_PAGE = "info:fedora/model:page";
  
  /** ID of digital object's datastream with text **/
  public static final String TEXT_OCR_DS_ID = "TEXT_OCR";
  
  /** ID of digital object's datastream with text **/
  public static final String IMG_FULL_DS_ID = "IMG_FULL";
  
  public static final Map<String, String> MIME_TYPES_MAPPING;
  
  static {
    MIME_TYPES_MAPPING = new HashMap<String, String>();
    MIME_TYPES_MAPPING.put("plain/text", "txt");
    MIME_TYPES_MAPPING.put("image/x-djvu", "djvu");
    MIME_TYPES_MAPPING.put("image/djvu", "djvu");
    MIME_TYPES_MAPPING.put("image/jpeg", "jpeg");
  }
 
  /**
   * Removes info:fedora/ from PID
   * @param pid
   * @return
   */
  public static String removeInfoFedora(String pid) {
    String result = null;
    if (pid!=null) {
      if (pid.startsWith("info:fedora/")) {   
        result = pid.substring("info:fedora/".length());
      } else {
        result = pid;
      }
    }
    return result;
  }

}
